/*
 Calculate one value of sine function to be sent to a 12 bit DAC
 U. Raich Nov. 2016
 This code is part of the workshop on embedded systems held at the
 University of Cape Coast, Ghana, for the first time during the summer
 semester 2017.
 The code is released under the GNU public license
 see: gnu.org/licenses/gpl-3.0.txt
*/

#include <stdlib.h>
#include <math.h>

/* this is the max number with 12 bits */
#define maxRange 0x0fff

short sineFunct(double x) {
  double sineValue;
  sineValue = (sin(x)+1)/2 * (double) maxRange;
  return (short) round(sineValue); 
}
