/*
 Generate a sine function to be sent to a 12 bit DAC
 U. Raich Nov. 2016
 The values are written to a text file named sine.txt
 This code is part of the workshop on embedded systems held at the
 University of Cape Coast, Ghana, for the first time during the summer
 semester 2017.
 The code is released under the GNU public license
 see: gnu.org/licenses/gpl-3.0.txt
*/

#include <stdio.h>
#include <math.h>
#define NO_OF_VALUES 100

extern short sineFunct(double x);

int main(int argc, char **argv) {
  FILE *sineFile;
  int xCount;
  double x;
  
  sineFile = fopen("sine.txt", "w");
  for (xCount=0; xCount < NO_OF_VALUES; xCount++) {
    x = 2*M_PI*(double)xCount/((double) NO_OF_VALUES);
    fprintf(stdout,"%d %10.4f %d\n",xCount,x,sineFunct(x));
    fprintf(sineFile,"%d\n",sineFunct(x));
  }
  fclose(sineFile);
}
